(* file: re.yacc *)
(* description: parser generator *)
(* author: Takahito Aoto *)

open Reg


(* 줾ΥѡȤʣȤϡ union Ȥ *)
(* 桼 *)
%%
%name		RegExp
%term           ID of string
              | LPAREN
              | RPAREN
              | AST
              | PLUS
              | VERT
              | DOT
              | LANGLE
              | RANGLE
              | DQUOTE
              | EOF 

%nonterm	XstartX of expr
              | XexprX of expr list
              | XtermX of expr list
              | XfactorX of expr
              | XidlistX of string list
              | XidX of expr
%pos	   	int
%eop		EOF
%noshift	EOF

%%
XstartX:      XexprX                       (simplify (UNION XexprX))
            | DQUOTE XexprX DQUOTE         (simplify (UNION XexprX))
XexprX:       XtermX VERT XexprX           ((CONCAT XtermX)::XexprX)
            | XtermX                       ([CONCAT XtermX])
            |                              ([])
XtermX:       XfactorX XtermX              (XfactorX::XtermX)
            | XfactorX                     ([XfactorX])
XfactorX:     XfactorX AST                 (STAR XfactorX)
            | XfactorX PLUS                (ITER XfactorX)
            | XidX                         (XidX)
XidX:         LPAREN XexprX RPAREN         (UNION XexprX)
            | DOT                          (ANY)
            | ID                           (SYMBOL ID)
            | LANGLE XidlistX RANGLE       (SYMBOL ("<" ^ (String.concat XidlistX) ^ ">"))
XidlistX:     ID XidlistX                  (ID::XidlistX)
            |                              ([])
