#!/bin/bash

command="sml @SMLload=checkmyfa.x86-linux"

case $1 in
    "M1") 
	echo -n "YES "; $command --dfa-check sipser-jt/M1.dfa
	echo -n "YES "; $command --dfa-accept "1101" sipser-jt/M1.dfa
	echo -n "YES "; $command --dfa-accept "0100" sipser-jt/M1.dfa
	echo -n "NO "; $command --dfa-accept "10" sipser-jt/M1.dfa
	;;

    "M2")
	echo -n "YES "; $command --dfa-check sipser-jt/M2.dfa
	echo -n "YES "; $command --dfa-accept "101" sipser-jt/M2.dfa
	echo -n "NO "; $command --dfa-accept "110" sipser-jt/M2.dfa
	;;

    "M3")
	echo -n "YES "; $command --dfa-check sipser-jt/M3.dfa
	echo -n "YES "; $command --dfa-accept "" sipser-jt/M3.dfa
	echo -n "YES "; $command --dfa-accept "110" sipser-jt/M3.dfa
	;;

    "M4")
	echo -n "YES "; $command --dfa-check sipser-jt/M4.dfa
	echo -n "YES "; $command --dfa-accept "bab" sipser-jt/M4.dfa
	echo -n "NO "; $command --dfa-accept "bbba" sipser-jt/M4.dfa
	;;

    "M5")
	echo -n "YES "; $command --dfa-check sipser-jt/M5.dfa
	echo -n "YES "; $command --dfa-accept "10<RESET>22<RESET>012" sipser-jt/M5.dfa
	;;

    "E1")
	echo -n "YES "; $command --dfa-check sipser-jt/E1.dfa
	echo -n "YES "; $command --dfa-accept "1101" sipser-jt/E1.dfa
	;;

    "E2")
	echo -n "YES "; $command --dfa-check sipser-jt/E2.dfa
	echo -n "YES "; $command --dfa-accept "0010" sipser-jt/E2.dfa
	echo -n "YES "; $command --dfa-accept "1001" sipser-jt/E2.dfa
	echo -n "NO "; $command --dfa-accept "11" sipser-jt/E2.dfa
	;;

    "exer-1-1-M1")
	echo -n "YES "; $command --dfa-check sipser-jt/exer-1-1-M1.dfa
	echo -n "NO "; $command --dfa-accept "aabb" --verbose sipser-jt/exer-1-1-M1.dfa
	echo -n "NO "; $command --dfa-accept "" --verbose sipser-jt/exer-1-1-M1.dfa
	;;

    "product")
	echo -n "YES "; $command --dfa-check sipser-jt/exer-1-4-b-1.dfa
	echo -n "YES "; $command --dfa-check sipser-jt/exer-1-4-b-2.dfa
	$command --dfa-product sipser-jt/exer-1-4-b-1.dfa sipser-jt/exer-1-4-b-2.dfa
	echo -n "YES "; $command --dfa-product sipser-jt/exer-1-4-b-1.dfa sipser-jt/exer-1-4-b-2.dfa | $command --dfa-accept "abbab"
	echo -n "NO "; $command --dfa-product sipser-jt/exer-1-4-b-1.dfa sipser-jt/exer-1-4-b-2.dfa | $command --dfa-accept "aba"
	echo -n "NO "; $command --dfa-product sipser-jt/exer-1-4-b-1.dfa sipser-jt/exer-1-4-b-2.dfa | $command --dfa-accept "abbbaa"
	;;

    "complement")
	echo -n "YES "; $command --dfa-check sipser-jt/exer-1-5-a.dfa
	echo -n "YES "; $command --dfa-accept "aabb" sipser-jt/exer-1-5-a.dfa
	$command --dfa-complement sipser-jt/exer-1-5-a.dfa
	echo -n "NO "; $command --dfa-complement sipser-jt/exer-1-5-a.dfa | $command --dfa-accept "aabb"
	;;

    "union")
	echo -n "YES "; $command --dfa-check sipser-jt/exer-1-4-b-1.dfa
	echo -n "YES "; $command --dfa-check sipser-jt/exer-1-4-b-2.dfa
	$command --dfa-union sipser-jt/exer-1-4-b-1.dfa sipser-jt/exer-1-4-b-2.dfa
	echo -n "YES "; $command --dfa-union sipser-jt/exer-1-4-b-1.dfa sipser-jt/exer-1-4-b-2.dfa | $command --dfa-accept "aba"
	echo -n "YES "; $command --dfa-union sipser-jt/exer-1-4-b-1.dfa sipser-jt/exer-1-4-b-2.dfa | $command --dfa-accept "aabba"
	echo -n "YES "; $command --dfa-union sipser-jt/exer-1-4-b-1.dfa sipser-jt/exer-1-4-b-2.dfa | $command --dfa-accept "abab"
	echo -n "NO "; $command --dfa-union sipser-jt/exer-1-4-b-1.dfa sipser-jt/exer-1-4-b-2.dfa | $command --dfa-accept "aaba"
	;;

    "subset")
	echo -n "YES "; $command --dfa-check sipser-jt/exer-1-5-b.dfa
	echo -n "NO "; $command --dfa-subset sipser-jt/exer-1-5-a.dfa sipser-jt/exer-1-5-b.dfa
	echo -n "YES "; $command --dfa-subset sipser-jt/exer-1-5-b.dfa sipser-jt/exer-1-5-a.dfa
	;;

    "minimize")
#	echo -n "YES "; $command --dfa-check kozen/example-13-1.dfa
#	$command --dfa-minimize kozen/example-13-1.dfa
#	echo -n "YES "; $command --dfa-check sipser-jt/exer-1-4-b-1.dfa
#	echo -n "YES "; $command --dfa-check sipser-jt/exer-1-4-b-2.dfa
#	$command --dfa-product sipser-jt/exer-1-4-b-1.dfa sipser-jt/exer-1-4-b-2.dfa |  $command --dfa-minimize
	echo -n "YES "; $command --dfa-check sipser-jt/exer-1-4-d-ans-1.dfa
	echo -n "YES "; $command --dfa-check sipser-jt/exer-1-4-d-ans-2.dfa
	$command --dfa-product sipser-jt/exer-1-4-d-ans-1.dfa sipser-jt/exer-1-4-d-ans-2.dfa |  $command --dfa-minimize |  $command --rename
	;;

    "equiv")
	echo -n "YES "; $command --dfa-check kozen/example-13-1.dfa
	echo -n "YES "; $command --dfa-minimize kozen/example-13-1.dfa | $command --dfa-equiv kozen/example-13-1.dfa
	;;

    "N1")
	echo -n "YES "; $command --nfa-check sipser-jt/N1.nfa
	echo -n "YES "; $command --nfa-accept "010110" sipser-jt/N1.nfa
	echo -n "YES "; $command --nfa-accept "010110" --verbose sipser-jt/N1.nfa
	;;

    "N2")
	echo -n "YES "; $command --nfa-check sipser-jt/N2.nfa
	echo -n "YES "; $command --nfa-accept "000100" sipser-jt/N2.nfa
	echo -n "NO "; $command --nfa-accept "0011" sipser-jt/N2.nfa
	$command --nfa-mkdfa sipser-jt/N2.nfa | $command --dfa-minimize  | $command --rename
	;;

    "N3")
	echo -n "YES "; $command --nfa-check sipser-jt/N3.nfa
	echo -n "YES "; $command --nfa-accept "" sipser-jt/N3.nfa
	echo -n "YES "; $command --nfa-accept "000" --verbose sipser-jt/N3.nfa
	echo -n "YES "; $command --nfa-accept "00" --verbose sipser-jt/N3.nfa
	echo -n "NO "; $command --nfa-accept "00000" sipser-jt/N3.nfa
	;;

    "N4")
	echo -n "YES "; $command --nfa-check sipser-jt/N4.nfa
	echo -n "YES "; $command --nfa-accept "" sipser-jt/N4.nfa
	echo -n "YES "; $command --nfa-accept "baba" sipser-jt/N4.nfa
	echo -n "NO "; $command --nfa-accept "b" sipser-jt/N4.nfa
	echo -n "NO "; $command --nfa-accept "babba" sipser-jt/N4.nfa
	$command --nfa-mkdfa sipser-jt/N4.nfa
	$command --nfa-mkdfa sipser-jt/N4.nfa | $command --dfa-minimize
	;;

    "concat")
	$command --re-mknfa "ab" "a" > sipser-jt/fig-1-56-a.nfa
	$command --re-mknfa "ab" "b" > sipser-jt/fig-1-56-b.nfa
	$command --nfa-concat sipser-jt/fig-1-56-a.nfa sipser-jt/fig-1-56-b.nfa
	;;

    "union")
	$command --re-mknfa "ab" "a" > sipser-jt/fig-1-56-a.nfa
	$command --re-mknfa "ab" "b" > sipser-jt/fig-1-56-b.nfa
	$command --nfa-concat sipser-jt/fig-1-56-a.nfa sipser-jt/fig-1-56-b.nfa > sipser-jt/fig-1-56-ab.nfa 
	$command --nfa-union sipser-jt/fig-1-56-ab.nfa sipser-jt/fig-1-56-a.nfa 
	;;

    "star")
	$command --re-mknfa "ab" "a" > sipser-jt/fig-1-56-a.nfa
	$command --re-mknfa "ab" "b" > sipser-jt/fig-1-56-b.nfa
	$command --nfa-concat sipser-jt/fig-1-56-a.nfa sipser-jt/fig-1-56-b.nfa > sipser-jt/fig-1-56-ab.nfa 
	$command --nfa-union sipser-jt/fig-1-56-ab.nfa sipser-jt/fig-1-56-a.nfa  > sipser-jt/fig-1-56-union.nfa 
	$command --nfa-star sipser-jt/fig-1-56-union.nfa
	;;

    "collapse")
	$command --re-mknfa "ab" "a" > sipser-jt/fig-1-56-a.nfa
	$command --re-mknfa "ab" "b" > sipser-jt/fig-1-56-b.nfa
	$command --nfa-concat sipser-jt/fig-1-56-a.nfa sipser-jt/fig-1-56-b.nfa > sipser-jt/fig-1-56-ab.nfa 
	$command --nfa-union sipser-jt/fig-1-56-ab.nfa sipser-jt/fig-1-56-a.nfa  > sipser-jt/fig-1-56-union.nfa 
	$command --nfa-star sipser-jt/fig-1-56-union.nfa > sipser-jt/fig-1-56-star.nfa 
	$command --nfa-collapse sipser-jt/fig-1-56-star.nfa | $command --rename
	;;

    "fig-1-67")
	echo -n "YES "; $command --dfa-check sipser-jt/fig-1-67.dfa
	$command --dfa-mkre sipser-jt/fig-1-67.dfa
	$command --dfa-mkre --verbose sipser-jt/fig-1-67.dfa
	;;

    *)
	;;
esac


